]> git.xonotic.org Git - xonotic/xonotic.git/blobdiff - misc/tools/xonotic-map-compiler-autobuild
now that we HAVE an official map, we can get rid of the ???????????????-????????...
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
index 6405eb2b1fe7fc62e6f56cdfedddd898cce96729..8f3f4aa0539ef84828a91b50378b0cd3bee7ecb2 100755 (executable)
@@ -4,6 +4,7 @@ set -e
 
 bspdir="$PWD/data"
 url=http://141.2.16.23/~xonotic/bsp-autobuilds/
+override="-bsp_timeout 900 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
 
 bspoutdir="$HOME/public_html/bsp-autobuilds/"
 
@@ -44,22 +45,25 @@ log2spam()
        url=$2
        branch=$3
        hash=$4
+       status=$5
+       time=$6
+
+       hash=`echo "$hash" | cut -c 1-7`
 
        branch=${branch##refs/heads/}
        branch=${branch##refs/remotes/}
        branch=${branch##origin/}
 
-       s_time=
        s_samplesize=
        s_failshaders=
        s_leaked=
        s_error=
 
+       if [ "$status" -ne 0 ]; then
+               s_error="exited with status $status"
+       fi
        while IFS= read -r L; do
                case "$L" in
-                       *\ seconds\ elapsed)
-                               s_time=$(($s_time + ${L%% seconds elapsed}))
-                               ;;
                        WARNING:\ surface\ at\ *\ too\ large\ for\ desired\ samplesize*)
                                s=${L##* }
                                if [ -z "$s_samplesize" ] || [ "$s" -gt "$s_samplesize" ]; then
@@ -85,9 +89,9 @@ log2spam()
        if [ -n "$s_error" ]; then
                echo -n "[$branch $hash] \ 34failed"
        else
-               echo -n "[$branch] finished"
+               echo -n "[$branch $hash] finished"
        fi
-       echo -n " map compile of $map ($url): $s_time sec"
+       echo -n " map compile of $map ($url): $time sec"
        if [ -n "$s_samplesize" ]; then
                echo -n ", FIX samplesize >= $s_samplesize"
        fi
@@ -121,14 +125,21 @@ buildthemap()
        if [ -n "$IRCSPAM" ]; then
                pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
        fi
+       t0=`date +%s`
        (
                cd maps
-               ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` 2>&1 | tee "$M.log"
+               ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $override > "$M.log"
        )
-       zip -9r "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
+       t1=`date +%s`
+       dt=$(($t1 - $t0))
+       status=$?
+       if [ -n "$IRCSPAM" ]; then
+               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" "$status" "$dt" > "maps/$M.irc"
+       fi
+       zip -9r "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
        ln -snf "../$M-$blobhash.pk3" "$bspdir/latest/$M.pk3" # from ALL branches, so beware!
        if [ -n "$IRCSPAM" ]; then
-               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
+               $IRCSPAM < "maps/$M.irc"
        fi
 }
 
@@ -145,12 +156,12 @@ getthemap()
        if ! wget -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
                rm -f "$bspdir/$M-$blobhash.pk3"
                echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
-               return 1
+               return 0
        fi
        if ! unzip -l "$bspdir/$M-$blobhash.pk3"; then
                rm -f "$bspdir/$M-$blobhash.pk3"
                echo "WARNING: could not download $url$M-$blobhash.pk3, invalid zip file"
-               return 1
+               return 0
        fi
 }
 
@@ -169,7 +180,11 @@ case "$1" in
                ;;
        download)
                mkdir -p "$bspdir" "$bspdir.old"
-               mv "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3 "$bspdir.old"/ || true
+               for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
+                       if [ -e "$b" ]; then
+                               mv "$b" "$bspdir.old"/
+                       fi
+               done
                cd data/xonotic-maps.pk3dir
                allmaps getthemap "$url" "$bspdir.old" "$bspdir"
                echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"
@@ -182,6 +197,6 @@ case "$1" in
                wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url""latest"
                ;;
        log2spam-test)
-               log2spam "mapname" "http://mapurl" "branch" "commit"
+               log2spam "mapname" "http://mapurl" "branch" "commit" "0"
                ;;
 esac